// Copyright 2001 by Columbia University. All rights reserved.

// stop the VC ++ compiler's complaints about STL
#ifdef WIN32
#pragma warning (disable:4786)
#endif

#ifdef WIN32
#include <AudioDevices/Win32AudioDevice.h>
#else
#include <AudioDevices/OSSAudioDevice.h>
#endif

const int AudioDevice::MAX_VOLUME = 100;
const int AudioDevice::DEFAULT_BLOCK_SIZE = 512;

AudioDevice::AudioDevice()
{
} // AudioDevice::AudioDevice


AudioDevice::~AudioDevice()
{
} // AudioDevice::~AudioDevice


DeviceCaps*
AudioDevice::getDevCaps()
{
#ifdef WIN32
  return Win32AudioDevice::getDevCaps();
#else 
  return OSSAudioDevice::getDevCaps();
#endif
} // AudioDevice::getDevCaps