// Copyright 2001 by Columbia University. All rights reserved.

// A simple exception class used by the audio device.

#ifndef AUDIODEVICEEXCEPTION_H
#define AUDIODEVICEEXCEPTION_H

#include <exception>
#include <string>

using namespace std;

class AudioDeviceException : public exception  
{
  public:

  AudioDeviceException(int error,const char *pMessage);
  AudioDeviceException(const char *pMessage);
  AudioDeviceException(int error,string &message);

  virtual ~AudioDeviceException();
  
  // Returns the message stored in the expection.
  virtual const char *what() const throw();

  inline int getAudioDeviceErrorCode(){return error;}

  protected:

  // This can be used as an error code.
  int error;

  // The message stored in the exception for later.
	 string message;

};

#endif