// Copyright 2001 by Columbia University. All rights reserved.

// stop the VC ++ compiler's complaints about STL
#ifdef WIN32
#pragma warning (disable:4786)
#endif

#ifdef WIN32
#include <AudioDevices/Win32AudioDevice.h>
#endif

#ifdef OSS
#include <AudioDevices/OSSAudioDevice.h>
#endif

#include <AudioDevices/AudioDeviceFactory.h>

AudioDeviceFactory::AudioDeviceFactory()
{
} // AudioDeviceFactory::AudioDeviceFactory


AudioDeviceFactory::~AudioDeviceFactory()
{
} // AudioDeviceFactory::~AudioDeviceFactory


DeviceCaps*
AudioDeviceFactory::buildDeviceCaps()
{

#ifdef WIN32
  DeviceCaps *pDeviceCaps = new Win32DeviceCaps();
#endif

#ifdef OSS
  DeviceCaps *pDeviceCaps = new DeviceCaps();
#endif

  return pDeviceCaps;

} // AudioDeviceFactory::buildDeviceCaps


AudioDevice* 
AudioDeviceFactory::buildAudioDevice()
{

#ifdef WIN32
  AudioDevice *pAudioDevice = new Win32AudioDevice();
#endif

#ifdef OSS
  AudioDevice *pAudioDevice = new OSSAudioDevice();
#endif

  return pAudioDevice;

} // AudioDeviceFactory::buildAudioDevice
