// Copyright 2001 by Columbia University. All rights reserved.

// This class allows one to probe devices and get handles to them. It
// should be used to create both DeviceCaps classes and AudioDevice
// classes.

#ifndef AUDIODEVICEFACTORY_H
#define AUDIODEVICEFACTORY_H

#include <AudioDevices/AudioDevice.h>

class AudioDeviceFactory
{
  public:

  AudioDeviceFactory();
  ~AudioDeviceFactory();

  // Creates a platform specific device capabilities class.
  // This function must be called to create a device capabilities
  // class. A DeviceCaps class should not be created directly by
  // the library's user.
  static DeviceCaps* buildDeviceCaps();

  // Creates a platform specific device class. A AudioDevice class
  // should not be created directly by the library's user.
  static AudioDevice* buildAudioDevice();
};

#endif