// Copyright 2001 by Columbia University. All rights reserved.

// stop the VC ++ compiler's complaints about STL
#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include <stdlib.h>
#include <AudioDevices/DevCap.h>

const int DevCap::NONE = -1;

DevCap::DevCap()
{
  devHandle = -1;
  blockSize = 512;
  inVolSupp = false;
  outVolSupp = false;
} // DevCap::DevCap


DevCap::DevCap(const DevCap &right)
{
  devHandle = right.devHandle;
  pName = right.pName;
  pAudioFormats = right.pAudioFormats;
  blockSize = right.blockSize;
  inVolSupp = right.inVolSupp;
  outVolSupp = right.outVolSupp;
} // DevCap::DevCap


DevCap::~DevCap() 
{
} // DevCap::~DevCap

void
DevCap::setDevHandle(DevHandle_t handle)
{
  this->devHandle = handle;
} // DevCap::setDevHandle


DevHandle_t
DevCap::getDevHandle()
{
  return devHandle;
} // DevCap::getDevHandle


void
DevCap::setDevName(string *pName)
{
  this->pName = pName;
} // DevCap::setDevName


string*
DevCap::getDevName()
{
  return pName;
} // DevCap::getDevName


void
DevCap::setAudioFormats(AudioFormats *pAudioFormats)
{
  this->pAudioFormats = pAudioFormats;
} // DevCap::setAudioFormats


AudioFormats*
DevCap::getAudioFormats()
{
  return pAudioFormats;
} // DevCap::getAudioFormats


void
DevCap::setBlockSize(int blockSize)
{
  this->blockSize = blockSize;
} // DevCap::setBlockSize


int
DevCap::getBlockSize()
{
  return blockSize;
} // DevCap::getBlockSize


void
DevCap::setInVolSupp(bool inVolSupp)
{
  this->inVolSupp = inVolSupp;
} // DevCap::setInVolSupp


bool
DevCap::getInVolSupp()
{
  return inVolSupp;
} // DevCap::getInVolSupp


void
DevCap::setOutVolSupp(bool outVolSupp)
{
  this->outVolSupp = outVolSupp;
} // DevCap::setOutVolSupp


bool
DevCap::getOutVolSupp()
{
  return outVolSupp;
} // DevCap::getOutVolSupp


void 
DevCap::setSampleRateToUse(AudioFormat::SampleRate sampleRate)
{
  settingsToUse.setSampleRate(sampleRate);
} // DevCap::setSampleRateToUse


AudioFormat::SampleRate
DevCap::getSampleRateToUse()
{
  return settingsToUse.getSampleRate();
} // DevCap::getSampleRateToUse


void
DevCap::setEncodingToUse(AudioFormat::Encoding encoding)
{
  settingsToUse.setEncoding(encoding);
} // DevCap::setEncodingToUse


AudioFormat::Encoding
DevCap::getEncodingToUse()
{
  return settingsToUse.getEncoding();
} // DevCap::getEncodingToUse


void
DevCap::setChannelToUse(AudioFormat::Channel channel)
{
  settingsToUse.setChannel(channel);
} // DevCap::setChannelToUse


AudioFormat::Channel
DevCap::getChannelToUse()
{
  return settingsToUse.getChannel();
} // DevCap::getChannelToUse


void
DevCap::setNumBitsToUse(AudioFormat::NumBits numBits)
{
  settingsToUse.setNumBits(numBits);
} // DevCap::setNumBitsToUse


AudioFormat::NumBits 
DevCap::getNumBitsToUse()
{
  return settingsToUse.getNumBits();
} // DevCap::getNumBitsToUse


void
DevCap::print()
{
  cout << "name " << pName->c_str() << endl;
  pAudioFormats->print();
  cout << "sample rate to use " << settingsToUse.getSampleRate() << endl;
  cout << "encoding to use " <<  settingsToUse.getEncoding() << endl;
  cout << "channel to use " <<  settingsToUse.getChannel() <<  endl;
  cout << "number of bits to use " << settingsToUse.getNumBits() << endl;
} // DevCap::print