// Copyright 2001 by Columbia University. All rights reserved.


#include <AudioDevices/OSSDeviceCaps.h>

OSSDeviceCaps::OSSDeviceCaps()
{
} // OSSDeviceCaps::OSSDeviceCaps


OSSDeviceCaps::OSSDeviceCaps(const OSSDeviceCaps &right)
{
  ossDevCaps = right.ossDevCaps;
  it = right.it;

} // OSSDeviceCaps::OSSDeviceCaps


OSSDeviceCaps::~OSSDeviceCaps()
{
} // OSSDeviceCaps::~OSSDeviceCaps


void
OSSDeviceCaps::setAudioDevName(DevHandle_t handle, string *pAudioDevName)
{
  Debug D("OSSDeviceCaps::setAudioDevName");

  checkHandle(handle);
  it->second.pAudioDevName = pAudioDevName;

} // OSSDeviceCaps::setAudioDevName


string*
OSSDeviceCaps::getAudioDevName(DevHandle_t handle)
{
  Debug D("OSSDeviceCaps::getAudioDevName");

  it = ossDevCaps.find(handle);
  if (it != ossDevCaps.end()) {
    return it->second.pAudioDevName;
  }

} // OSSDeviceCaps::getAudioDevName


void
OSSDeviceCaps::setMixerDevName(DevHandle_t handle, string* pMixerDevName)
{
  Debug D("OSSDeviceCaps::setMixerDevName");

  checkHandle(handle);
  it->second.pMixerDevName = pMixerDevName;

} // OSSDeviceCaps::setMixerDevName



string*
OSSDeviceCaps::getMixerDevName(DevHandle_t handle)
{
  Debug D("OSSDeviceCaps::getMixerDevName");

  it = ossDevCaps.find(handle);
 
  return it->second.pMixerDevName;

} // OSSDeviceCaps::getMixerDevName


void
OSSDeviceCaps::checkHandle(DevHandle_t handle)
{
  Debug D("OSSDeviceCaps::checkHandle");

  it = ossDevCaps.find(handle);
  if (it == ossDevCaps.end() || ossDevCaps.empty()) {
    OSSDevCap ossDevCap;
    ossDevCaps[handle] = ossDevCap;
  }

  it  = ossDevCaps.find(handle);

} // OSSDeviceCaps::checkHandle
