// Copyright 2001 by Columbia University. All rights reserved.

// This class stores information about one audio device. It is used by
// DeviceCaps as the basic unit of information about a device. Information
// about the interogated device is stored here. The library's user should
// not really have to be concerned with this class.

// This class is used by the win32AudioDevice driver to add functionality
// to the basic DevCap class needed for win32.

#ifndef WIN32INDEVCAP_H
#define WIN32INDEVCAP_H

#include <windows.h>
#include <AudioDevices/DevCap.h>

class Win32DevCap : public DevCap
{
  public:

  // The wave in device identifier according to win32.
  UINT waveInDesc;

  // The wave out device identifier according to win32.
  UINT waveOutDesc;

  // The mixer device identifier according to win32.
  UINT mixerDesc;

  // The mixer line id used to change the input volume.
  DWORD recLine;

  protected:

  private:
};

#endif