// Copyright 2001 by Columbia University. All rights reserved.

// stop the VC ++ compiler's complaints about STL
#pragma warning (disable:4786)

#include <AudioDevices/Win32DeviceCaps.h>

Win32DeviceCaps::Win32DeviceCaps()
{
} // Win32DeviceCaps::Win32DeviceCaps


Win32DeviceCaps::Win32DeviceCaps(const Win32DeviceCaps &right)
{
  win32DevCaps = right.win32DevCaps;
  it = right.it;
} // Win32DeviceCaps::Win32DeviceCaps


Win32DeviceCaps::~Win32DeviceCaps()
{
} // Win32DeviceCaps::~Win32DeviceCaps


void
Win32DeviceCaps::setRecLine(DevHandle_t handle, DWORD recLine)
{
  Debug D("Win32DeviceCaps::setRecLine");

  checkHandle(handle);
  it->second.recLine = recLine;

} // Win32DeviceCaps::setRecLine


DWORD
Win32DeviceCaps::getRecLine(DevHandle_t handle)
{
  Debug D("Win32DeviceCaps::::getRecLine");
  
  it = win32DevCaps.find(handle);
  return it->second.recLine;
} // Win32DeviceCaps::getRecLine


void
Win32DeviceCaps::setWaveInDesc(DevHandle_t handle, UINT waveInDesc)
{
  Debug D("Win32DeviceCaps::setWaveInDesc");

  checkHandle(handle);
  it->second.waveInDesc = waveInDesc;
} // Win32DeviceCaps::setWaveInDesc


void
Win32DeviceCaps::setWaveOutDesc(DevHandle_t handle, UINT waveOutDesc)
{
  Debug D("Win32DeviceCaps::setWaveOutDesc");

  checkHandle(handle);
  it->second.waveOutDesc = waveOutDesc;
} // Win32DeviceCaps::setWaveOutDesc


UINT
Win32DeviceCaps::getWaveInDesc(DevHandle_t handle)
{
  Debug D("Win32DeviceCaps::getWaveInDesc");

  it = win32DevCaps.find(handle);
  if (it != win32DevCaps.end()) {
    return it->second.waveInDesc;
  }
  else {
    return DevCap::NONE;
  }
} // Win32DeviceCaps::getWaveInDesc


UINT
Win32DeviceCaps::getWaveOutDesc(DevHandle_t handle)
{
  Debug D("Win32DeviceCaps::getWaveOutDesc");

  it = win32DevCaps.find(handle);
 
  return it->second.waveOutDesc;
} // Win32DeviceCaps::getWaveOutDesc


void
Win32DeviceCaps::setMixerDesc(DevHandle_t handle, UINT mixerDesc)
{
  Debug D("Win32DeviceCaps::setMixerDesc");

  checkHandle(handle);
  it->second.mixerDesc = mixerDesc;
} // Win32DeviceCaps::setMixerDesc


UINT
Win32DeviceCaps::getMixerDesc(DevHandle_t handle)
{
  Debug D("Win32DeviceCaps::getMixerDesc");

  it = win32DevCaps.find(handle);
  return it->second.mixerDesc;
} // Win32DeviceCaps::getMixerDesc


void
Win32DeviceCaps::checkHandle(DevHandle_t handle)
{
  Debug D("Win32DeviceCaps::checkHandle");

  it = win32DevCaps.find(handle);
  if (it == win32DevCaps.end() || win32DevCaps.empty()) {
    Win32DevCap win32DevCap;
    win32DevCaps[handle] = win32DevCap;
  }

  it  = win32DevCaps.find(handle);
} // Win32DeviceCaps::checkHandle