// AUAudioFile.cpp: implementation of the AUAudioFile class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _MSC_VER
#pragma warning(disable:4786)
#endif

#include "AUAudioFile.h"

#include <Utils/Debug.h>

#include <iostream>

using namespace std;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

AUAudioFile::AUAudioFile(istream &stream)
:AudioFile(stream)
{

  Debug D("AUAudioFile::AUAudioFile");

  AudioFormat::Encoding encoding;
  AudioFormat::SampleRate samplerate;
  AudioFormat::NumBits samplebits;
  AudioFormat::Channel channels;
  int blocksize;
  
  char buf[5];
  
  //data offset
  stream.get(buf,5);
  int offset = ntohl(*(int*)buf);

  D.Dbg("medium","Data starts at: ",offset);
  
  //data size
  stream.get(buf,5);
  int datasize = ntohl(*(int*)buf);

  D.Dbg("medium","Data bytes in file: ",datasize);
  
  //encoding
  stream.get(buf,5);
  
  encoding = intToEncoding(ntohl(*(int*)buf));
  D.Dbg("medium","Encoding: ",encoding);
  //cout <<  << encoding << " Sample bits: " << samplebits << endl;
  
  //sample rate
  stream.get(buf,5);
  samplerate = AudioFormat::intToSampleRate(ntohl(*(int*)buf));
  
  cout << "Sample Rate: " << samplerate << endl;
  
  //channels
  stream.get(buf,5);
  channels = AudioFormat::intToChannel(ntohl(*(int*)buf));
  
  cout << "Number of channels: " << channels << endl;

  audioFormat->setEncoding(encoding);
  audioFormat->setSampleRate(samplerate);
  
  //AudioFormat af(encoding, samplerate, samplebits, channels, blocksize);
  
  //move stream to start of data
  stream.seekg(offset);
}

AUAudioFile::~AUAudioFile()
{

}

AudioFormat::Encoding AUAudioFile::intToEncoding(int dataFormat)
{

  AudioFormat::Encoding encoding;
  
  switch(dataFormat){
  case 1:
    encoding = AudioFormat::S16;
    break;
  }

  return encoding;

}

void AUAudioFile::read(char *buf, int &length)
{

  stream.read(buf,length);

  length = stream.gcount();

}
