// AudioFileFactory.cpp: implementation of the AudioFileFactory class.
//
//////////////////////////////////////////////////////////////////////

#include "AudioFileFactory.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#include <string>

#include "AUAudioFile.h"
#include "WAVAudioFile.h"

using namespace std;

AudioFileFactory::AudioFileFactory()
{

}

AudioFileFactory::~AudioFileFactory()
{

}

AudioFile * AudioFileFactory::buildAudioFile(istream &stream)
{

  char buf[5];
  
  stream.get(buf,5);
  
  string magic(buf);
  
  cout << "File type" << endl;
  cout << magic << endl;
  
  switch(buf[0]){
  case '.':
    return new AUAudioFile(stream);
    break;
    
  case 'R':
    return new WAVAudioFile(stream);
    break;
  }

  return NULL;
}
