// WAVAudioFile.h: interface for the WAVAudioFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVAUDIOFILE_H__68724E2D_C88D_4FDC_98CF_F9A2ABE9A94E__INCLUDED_)
#define AFX_WAVAUDIOFILE_H__68724E2D_C88D_4FDC_98CF_F9A2ABE9A94E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AudioFile.h"
#include <Common/AudioFormat.h>

class WAVAudioFile : public AudioFile  
{
public:
	virtual void read(char* buf, int &length);
	static AudioFormat::Encoding intToEncoding(int wFormatTag);
	WAVAudioFile(istream &stream);
	virtual ~WAVAudioFile();
protected:
	void initAudioFormat();
	void readToDataChunk();
  int filesize;
  string wavstring;
  string fmtchunk;
  int fmtchunksize;
  int wFormatTag;
  int nChannels;
  int nSamplesPerSec;
  int nAvgBytesPerSec;
  int nBlockAlign;
  int wBitsPerSample;
  int cbSize;
  string datastring;

};

#endif // !defined(AFX_WAVAUDIOFILE_H__68724E2D_C88D_4FDC_98CF_F9A2ABE9A94E__INCLUDED_)
