// CodecState.h: Defines the abstract CodecState class.  Provides common
// interface to access the various CodecStates.
//
// Copyright (c) 2001 by Columbia University. All rights reserved.
//////////////////////////////////////////////////////////////////////

#if !defined(_CODECSTATE_H_)
#define _CODECSTATE_H_

class CodecState  
{
public:
  // Creates new CodecState
	CodecState();

  // Destructor
	virtual ~CodecState();

  //@return The current codec state.
	unsigned char* getState(){return state;}

  //Sets the current state
  //@param state The new state.
	void setState(unsigned char* state){this->state = state;}

protected:

  //State data.  It is the responsibility of the
  //subclass to deallocate this member.
	unsigned char* state;

};

#endif // !defined(_CODECSTATE_H_)
