// GSM.h: Definition of GSM class.  Implements the
// abstract Codec interface.  Function comments may be found in Codec.h
// 
// Copyright (c) 2001 by Columbia University. All rights reserved.
//////////////////////////////////////////////////////////////////

#if !defined(_GSM_H_)
#define _GSM_H_

#include "Codec.h"
#include <Utils/factory.h>

class GSM : public Codec  
{
public:
  //Functions defined in Codec.  See Codec.h for documentation.
	virtual void resetState();
	virtual void 
    encode(unsigned short *inbuf, unsigned char *outbuf, int &length);
	virtual void 
    decode(unsigned char *inbuf, unsigned short *outbuf, int &length);

  //constructor
	GSM();

  //destructor
	virtual ~GSM();

};

//Register this codec with factory.
namespace{
  static registerInFactory<Codec, GSM> registerGSM("GSM");
  static registerInFactory<Codec, GSM> registergsm("gsm");
}

#endif // !defined(_GSM_H_)
