// dvi.h: Definition of DVI class.  Implements the
// abstract Codec interface.  Function comments may be found in Codec.h
// 
// Copyright (c) 2001 by Columbia University. All rights reserved.
//////////////////////////////////////////////////////////////////
#if !defined(_DVI_H_)
#define _DVI_H_

#include "Codec.h"
#include <Utils/factory.h>

class DVI: public Codec
{
public:
  //Functions defined by abstract Codec class.  See Codec.h for definition.
	virtual void resetState();
  virtual void 
    decode(unsigned char *inbuf, unsigned short *outbuf, int &length);
  virtual void 
    encode(unsigned short *inbuf, unsigned char *outbuf, int &length);
  
  //Constructor
  DVI();

};

//Register this codec with the codec factory.
namespace{
  static registerInFactory<Codec, DVI> registerDVI("DVI");
  static registerInFactory<Codec, DVI> registerdvi("dvi");
}

#endif //!defined(_DVI_H_)
