// Copyright 2001 year by Columbia University. All rights reserved.

// stop the compiler's complaints about STL
#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include <Common/AudioFormat.h>

const int AudioFormat::NO_FORMAT = -1;

AudioFormat::AudioFormat()
:sampleRate((SampleRate)NULL),encoding((Encoding)NULL)
,channel((Channel)NULL),numBits((NumBits)NULL),bytesPerBlock(0)
{
} // AudioFormat::AudioFormat


AudioFormat::AudioFormat(const AudioFormat &right)
:sampleRate(right.sampleRate),encoding(right.encoding)
,channel(right.channel),numBits(right.numBits)
,bytesPerBlock(right.bytesPerBlock)
{
} // AudioFormat::AudioFormat


AudioFormat::~AudioFormat()
{
} // AudioFormat::~AudioFormat


int
AudioFormat::operator&(AudioFormat &right)
{
  int count = 0;

  if (bytesPerBlock == right.bytesPerBlock)
      count++;

  if (channel == right.channel)
      count++;

  if (encoding == right.encoding)
      count++;

  if (sampleRate == right.sampleRate)
      count++;

  if (numBits == right.numBits)
      count++;

  return count;

} // AudioFormat::operator&


AudioFormat::SampleRate
AudioFormat::intToSampleRate(int sampleRate)
{
  SampleRate eSR;
  
  switch (sampleRate) {
    case 8000:
    case 8012:
      eSR = AudioFormat::S8K;
      break;
    case 11025:
      eSR = AudioFormat::S11K;
      break;
    case 16000:
      eSR = AudioFormat::S16K;
      break;
    case 22050:
      eSR = AudioFormat::S22K;
      break;
    case 24000:
      eSR = AudioFormat::S24K;
      break;
    case 32000:
      eSR = AudioFormat::S32K;
      break;
    case 44100:
      eSR = AudioFormat::S44K;
      break;
    case 48000:
      eSR = AudioFormat::S48K;
      break;
    default:
      break;
  };
  
  return eSR;

} // AudioFormat::intToSampleRate


AudioFormat::Channel
AudioFormat::intToChannel(int channel)
{
  Channel eCH;
  
  switch (channel) {
    case 1:
      eCH = MONO;
      break;
    case 2:
      eCH = STEREO;
      break;
    default:
      break;
  };
  
  return eCH;

} // AudioFormat::intToChannel


AudioFormat::NumBits
AudioFormat::intToNumBits(int numBits)
{
  NumBits eNB;

  switch (numBits) {
    case 8:
      eNB = B8;
      break;
    case 16:
      eNB = B16;
      break;
    default:
      break;
  };

  return eNB;

} // AudioFormat::intToNumBits