// CodecFormat.cpp: implementation of the CodecFormat class.
//
// Copyright (c) 2001 by Columbia University. All rights reserved.
//////////////////////////////////////////////////////////////////////
#ifdef WIN32
#pragma warning(disable:4786) //disables nasty vc++ warning caused by stl
#endif

#include <Common/CodecFormat.h>

// CodecFormat::CodecFormat(string name, string description, char defaultPt, 
//  short stateSize, short frameSize,const AudioFormat &audioFormat)
// Constructor. Initializes members to passed parameters.
CodecFormat::CodecFormat(string name, string description, char defaultPt, 
  short stateSize, short frameSize,const AudioFormat &audioFormat)
: name(name),description(description),defaultPt(defaultPt),stateSize(stateSize),
frameSize(frameSize),audioFormat(NULL)
{
	this->audioFormat = new AudioFormat(audioFormat);

}//CodecFormat::CodecFormat

// CodecFormat::CodecFormat( const CodecFormat &right)
// Copy Constructor.  Copies each member of passed CodecFormat.
CodecFormat::CodecFormat( const CodecFormat &right)
{
	this->audioFormat = new AudioFormat(*(right.audioFormat));
	name = right.name;
	description = right.description;
	defaultPt = right.defaultPt;
	stateSize = right.stateSize;
	frameSize = right.frameSize;

}//CodecFormat::CodecFormat

// CodecFormat::~CodecFormat()
// Destructor
CodecFormat::~CodecFormat()
{
	delete audioFormat;
}//CodecFormat::~CodecFormat
