// RTPCommon.cpp: Implementation of functions defined in RTPCommon.h
//
// Copyright (c) 2001 by Columbia University. All rights reserved.
///////////////////////////////////////////////////////////////////

#include <winsock.h>
#include <sys/types.h>
#include <sys/timeb.h>

// gettimeofday(struct timeval *tp, void *unused)
// Converts windows function to posix function call.
void gettimeofday(struct timeval *tp, void *unused)
{
  
  struct _timeb wt;
  
  _ftime(&wt);
  tp->tv_sec = wt.time;
  tp->tv_usec = wt.millitm * 1000;
  
}//gettimeofday(struct timeval *tp, void *unused) 

// tv2dbl(timeval &tv)
// same as function defined in RTP library examples
double tv2dbl(timeval &tv)
{
  return tv.tv_sec + tv.tv_usec / 1000000.0;
}//tv2dbl(timeval &tv)

// dbl2tv(double d)
// same as function defined in RTP library examples
timeval dbl2tv(double d) 
{
  struct timeval tv;
  
  tv.tv_sec = (long) d;
  tv.tv_usec = (long) ((d - (long) d) * 1000000.0);
  
  return tv;
}//dbl2tv(double d) 