// RTPCommon.h: Defines functions used by the RTP library that are not 
// available on all platforms or that need to be defined globally.
//
// Copyright (c) 2001 by Columbia University. All rights reserved.
///////////////////////////////////////////////////////////////////

#ifndef _RTPCOMMON_H_
#define _RTPCOMMON_H_

#ifdef WIN32
#include <winsock.h>
#else
#include <sys/time.h>
#include <unistd.h>
#endif

// Standard RTP includes
extern "C"{
#include <rtp_api.h>
#include <rtp_highlevel.h>
}

#ifdef WIN32
// defines posix function unsupported on windows
void gettimeofday(struct timeval *tp, void *unused);
#endif

// Convert a struct timeval to a double
double tv2dbl(timeval &tv);

// Convert a double to a struct timeval
timeval dbl2tv(double d);

#endif
