// RTPEvent.cpp: implementation of the RTPEvent class.
//
// Copyright (c) 2001 by Columbia University. All rights reserved.
//////////////////////////////////////////////////////////////////////

#ifdef WIN32
#pragma warning (disable:4786)
#endif

#include "RTPEvent.h"

// RTPEvent::RTPEvent(int cid,rtp_opaque_t opaque, timeval *tp)
// Initializes appropriate members.
RTPEvent::RTPEvent(int cid,rtp_opaque_t opaque, timeval *tp)
:cid(cid),opaque(opaque)
{
  time = tv2dbl(*tp);
}//RTPEvent::RTPEvent

// RTPEvent::~RTPEvent()
RTPEvent::~RTPEvent()
{
}//RTPEvent::~RTPEvent

// RTPEvent::RTPEvent()
RTPEvent::RTPEvent()
:cid(0),opaque(NULL),time(0.0)
{
  
}//RTPEvent::RTPEvent

//RTPEvent & RTPEvent::operator =(const RTPEvent &right)
// Allows for assignment of this event object.
RTPEvent & RTPEvent::operator =(const RTPEvent &right)
{
  cid = right.cid;
  opaque = right.opaque;
  time = right.time;
  
  return *this;
}//RTPEvent & RTPEvent::operator =(const RTPEvent &right)

// RTPEvent::RTPEvent(const RTPEvent &right)
// Copy Constructor
RTPEvent::RTPEvent(const RTPEvent &right)
:cid(right.cid),time(right.time),opaque(right.opaque)
{
  
}//RTPEvent::RTPEvent(const RTPEvent &right)
