// WinsockDLL.cpp: implementation of the WinsockDLL class.
//
// Copyright (c) 2001 by Columbia University. All rights reserved.
//////////////////////////////////////////////////////////////////////

#include "WinsockDLL.h"

#ifdef WIN32
#include <winsock2.h>
#endif

// WinsockDLL::WinsockDLL()
// Initilizes the winsock dll.
// This is windows specific and is provided for
// portability.  It does not have a counterpart on
// other platforms.
WinsockDLL::WinsockDLL()
{
#ifdef WIN32
  WORD wVersionRequested;
  WSADATA wsaData;
  int err2;
  
  // use winsock version 2.0
  wVersionRequested = MAKEWORD( 2, 0 );
  
  err2 = ::WSAStartup( wVersionRequested, &wsaData );
  if ( err2 != 0 ) {
    /* Tell the user that we couldn't find a usable */
    /* WinSock DLL.                                  */
  }
#endif
}//WinsockDLL::WinsockDLL()

// WinsockDLL::~WinsockDLL()
// Closes the winsock dll.
// This is windows specific and is provided for
// portability.  It does not have a counterpart on
// other platforms
WinsockDLL::~WinsockDLL()
{
#ifdef WIN32
  ::WSACleanup();
#endif
}//WinsockDLL::~WinsockDLL()
