#include <Utils/Condition.h>
#include <Utils/Thread.h>
#include <Utils/Mutex.h>

#include <iostream>

using namespace std;

class X : public Thread
{
public:
  X(Condition& cond, Mutex& mutex, int id):cond_(cond),mutex_(mutex),id(id){
  }

protected:

  Condition& cond_;
  Mutex& mutex_;
  int id;


  void exec(){
    cout << "Waiting for signal" << endl;

    mutex_.acquire();

    cond_.wait();

    mutex_.release();

    cout << "Thread signaled: " << id << endl;
  } 
};

void main()
{
  Mutex mutex;
  Condition cond(mutex);

  X x1(cond,mutex,1);
  X x2(cond,mutex,2);
  X x3(cond,mutex,3);

  x1.start();
  x2.start();

  cout << "Wait to signal" << endl;
  char y;
  cin >> y;

  mutex.acquire();

  cond.signalAll();

  mutex.release();

  cout << "wait to start next test" << endl;
  char z;
  cin >> z;

  x3.start();

  cout << "wait to signal " << endl;
  cin >> z;
  mutex.acquire();

  cond.signal();

  mutex.release();

  char x;
  cin >> x;

}